const async = require('async');
const fs = require('fs');
const _ = require('lodash');

async.series([
    // this is the first element of the array of functions
    (callback) => {
        fs.readFile('a.log', (err, data) => {
            if (err) throw err;
            callback(null, data.toString().trim().split(/\n/));
        });
    },

    // this is the second element of the array of functions
    (callback) => {
        fs.readFile('b.log', (err, data) => {
            if (err) throw err;
            callback(null, data.toString().trim().split(/\n/));
        });
    },

    // this is the third element of the array of functions
    (callback) => {
        fs.readFile('c.log', (err, data) => {
            if (err) throw err;
            callback(null, data.toString().trim().split(/\n/));
        });
    }

// end of the array of functions we want to run
// results is now an array of all of the results of our tasks being executed
// this is the function referred to as "callback" in the tasks, above
], function(err, results) {
    if (err) throw err;
    console.log(_.flatten(results));
});
