const async = require('async');
const fs = require('fs');
const _ = require('lodash');

async.parallel([

    // first task
    (callback) => {
        fs.readFile('a.log', (err, data) => {
            console.log('done with a');
            if (err) throw err;
            callback(null, data.toString().trim().split(/\n/));
        });
    },

    // second task
    (callback) => {
        fs.readFile('b.log', (err, data) => {
            console.log('done with b');
            if (err) throw err;
            callback(null, data.toString().trim().split(/\n/));
        });
    },

    // third task
    (callback) => {
        fs.readFile('c.log', (err, data) => {
            console.log('done with c');
            if (err) throw err;
            callback(null, data.toString().trim().split(/\n/));
        });
    }

// callback function, referred to as "callback" in the tasks above
], function(err, results) {
    if (err) throw err;
    console.log(_.flatten(results));
});
