const async = require('async');
const fs = require('fs');
const _ = require('lodash');

let lines = [];

// this is basically equivalent to series, but much more streamlined!
async.eachSeries(['a.log', 'b.log', 'c.log'], (file, callback) => {

    // open each file (in SERIES, a then b then c)
    fs.readFile(file, (err, data) => {
        console.log(`done with ${file}`);
        if (err) throw err;

        // concatenate each of the results onto the lines array
        lines = _.concat(lines, data.toString().trim().split(/\n/));

        // basically signalling "I'm done!", callback refers to the function on 23
        callback();
    });

// here's our callback, for when all of the tasks are finished
}, function(err) {
    if (err) throw err;
    console.log(lines);
});
